# coding: utf-8

"""
    BombBomb

    We make it easy to build relationships using simple videos.

    OpenAPI spec version: 2.0.22196
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""

from pprint import pformat
from six import iteritems
import re


class PromptBotBot(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, email_id=None, list_id=None, prompt_subject=None, prompt_body=None, start_date=None, end_date=None, bot_type_id=None, template_id=None):
        """
        PromptBotBot - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'id': 'str',
            'user_id': 'str',
            'email_id': 'str',
            'list_id': 'str',
            'prompt_subject': 'str',
            'prompt_body': 'str',
            'status': 'str',
            'start_date': 'datetime',
            'end_date': 'datetime',
            'bot_type_id': 'str',
            'template_id': 'str'
        }

        self.attribute_map = {
            'id': 'id',
            'user_id': 'userId',
            'email_id': 'emailId',
            'list_id': 'listId',
            'prompt_subject': 'promptSubject',
            'prompt_body': 'promptBody',
            'status': 'status',
            'start_date': 'startDate',
            'end_date': 'endDate',
            'bot_type_id': 'botTypeId',
            'template_id': 'templateId'
        }

        self._id = None
        self._user_id = None
        self._status = None
        self._email_id = email_id
        self._list_id = list_id
        self._prompt_subject = prompt_subject
        self._prompt_body = prompt_body
        self._start_date = start_date
        self._end_date = end_date
        self._bot_type_id = bot_type_id
        self._template_id = template_id

    @property
    def id(self):
        """
        Gets the id of this PromptBotBot.
        The identifier of the prompt bot. Read Only.

        :return: The id of this PromptBotBot.
        :rtype: str
        """
        return self._id

    @property
    def user_id(self):
        """
        Gets the user_id of this PromptBotBot.
        The prompt bot's owner. Read Only.

        :return: The user_id of this PromptBotBot.
        :rtype: str
        """
        return self._user_id

    @property
    def email_id(self):
        """
        Gets the email_id of this PromptBotBot.
        The default email being sent to contacts in the prompt bot list.

        :return: The email_id of this PromptBotBot.
        :rtype: str
        """
        return self._email_id

    @email_id.setter
    def email_id(self, email_id):
        """
        Sets the email_id of this PromptBotBot.
        The default email being sent to contacts in the prompt bot list.

        :param email_id: The email_id of this PromptBotBot.
        :type: str
        """

        self._email_id = email_id

    @property
    def list_id(self):
        """
        Gets the list_id of this PromptBotBot.
        The list to attach the Prompt Bot to.

        :return: The list_id of this PromptBotBot.
        :rtype: str
        """
        return self._list_id

    @list_id.setter
    def list_id(self, list_id):
        """
        Sets the list_id of this PromptBotBot.
        The list to attach the Prompt Bot to.

        :param list_id: The list_id of this PromptBotBot.
        :type: str
        """

        self._list_id = list_id

    @property
    def prompt_subject(self):
        """
        Gets the prompt_subject of this PromptBotBot.
        The prompt subject.

        :return: The prompt_subject of this PromptBotBot.
        :rtype: str
        """
        return self._prompt_subject

    @prompt_subject.setter
    def prompt_subject(self, prompt_subject):
        """
        Sets the prompt_subject of this PromptBotBot.
        The prompt subject.

        :param prompt_subject: The prompt_subject of this PromptBotBot.
        :type: str
        """

        self._prompt_subject = prompt_subject

    @property
    def prompt_body(self):
        """
        Gets the prompt_body of this PromptBotBot.
        The prompt body.

        :return: The prompt_body of this PromptBotBot.
        :rtype: str
        """
        return self._prompt_body

    @prompt_body.setter
    def prompt_body(self, prompt_body):
        """
        Sets the prompt_body of this PromptBotBot.
        The prompt body.

        :param prompt_body: The prompt_body of this PromptBotBot.
        :type: str
        """

        self._prompt_body = prompt_body

    @property
    def status(self):
        """
        Gets the status of this PromptBotBot.
        The status of the prompt bot. Read Only.

        :return: The status of this PromptBotBot.
        :rtype: str
        """
        return self._status

    @property
    def start_date(self):
        """
        Gets the start_date of this PromptBotBot.
        when the bot started

        :return: The start_date of this PromptBotBot.
        :rtype: datetime
        """
        return self._start_date

    @start_date.setter
    def start_date(self, start_date):
        """
        Sets the start_date of this PromptBotBot.
        when the bot started

        :param start_date: The start_date of this PromptBotBot.
        :type: datetime
        """

        self._start_date = start_date

    @property
    def end_date(self):
        """
        Gets the end_date of this PromptBotBot.
        when the bot should finish

        :return: The end_date of this PromptBotBot.
        :rtype: datetime
        """
        return self._end_date

    @end_date.setter
    def end_date(self, end_date):
        """
        Sets the end_date of this PromptBotBot.
        when the bot should finish

        :param end_date: The end_date of this PromptBotBot.
        :type: datetime
        """

        self._end_date = end_date

    @property
    def bot_type_id(self):
        """
        Gets the bot_type_id of this PromptBotBot.
        The type of bot.

        :return: The bot_type_id of this PromptBotBot.
        :rtype: str
        """
        return self._bot_type_id

    @bot_type_id.setter
    def bot_type_id(self, bot_type_id):
        """
        Sets the bot_type_id of this PromptBotBot.
        The type of bot.

        :param bot_type_id: The bot_type_id of this PromptBotBot.
        :type: str
        """

        self._bot_type_id = bot_type_id

    @property
    def template_id(self):
        """
        Gets the template_id of this PromptBotBot.
        The template id used to generate the default email.

        :return: The template_id of this PromptBotBot.
        :rtype: str
        """
        return self._template_id

    @template_id.setter
    def template_id(self, template_id):
        """
        Sets the template_id of this PromptBotBot.
        The template id used to generate the default email.

        :param template_id: The template_id of this PromptBotBot.
        :type: str
        """

        self._template_id = template_id

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
